'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

function _interopDefault (ex) { return (ex && (typeof ex === 'object') && 'default' in ex) ? ex['default'] : ex; }

var nodePath = _interopDefault(require('path'));
var helperModuleImports = require('@babel/helper-module-imports');

function plugin() {
  return {
    visitor: {
      TSAsExpression(asExpressionPath) {
        let expressionPath = asExpressionPath.get("expression");

        if (expressionPath.node.type === "TaggedTemplateExpression" && expressionPath.node.tag.type === "Identifier" && expressionPath.node.tag.name === "gql" && asExpressionPath.node.type === "TSAsExpression" && asExpressionPath.node.typeAnnotation.type === "TSImportType") {
          expressionPath.replaceWith(helperModuleImports.addNamed(expressionPath, "document", asExpressionPath.node.typeAnnotation.argument.value, {
            nameHint: nodePath.basename(asExpressionPath.node.typeAnnotation.argument.value)
          }));
        }
      }

    }
  };
}

exports.default = plugin;
